local functions = require "functions"
local utils = require "utils"
magnitud = {
	set = false
}
magn = {
	x = 0,
	y = 0
}
local ball = {}
ball.collision = function (r,a,pad,world)
	if r > pad.rm and r < pad.mr then
		if not pad.d then pad.d = 1.5 end
		local lef = (pad.a - pad.d/2) % utils.twopi
		local rig = (pad.a + pad.d/2) % utils.twopi
		local a = a % utils.twopi
		if rig < lef then
			if lef > a then
				lef = lef - utils.twopi
			elseif rig < a then
				rig = rig + utils.twopi
			end
		end
		if a > lef and a < rig then
			return "paddle"
		end
	elseif r < world.r then
		return "world"
	else
		return false
	end
end
ball.create = function ()
	local hold = {}
	hold.a = love.math.random(100000)/50000 * math.pi 
	hold.r = screen.commonr
	hold.speed = 400 * love.math.random(100000)/100000
	hold.w = 20
	hold.radius = 4
	hold.ps = functions.cloneps("normal",hold,30,10)
	return hold
end
ball.update = function (dt,hold,pad)
	if not hold.destroyed then
		hold.r = hold.r - hold.speed * dt
		local c = ball.collision(hold.r,hold.a,pad,world)
		hold.ps:moveTo(math.rec(hold.r,hold.a))
		hold.ps:update(dt)
		local r,g,b = utils.color(true)
		functions.particolors(hold.ps,r,g,b)		
		if c then
			hold.destroyed = true
			hold.destroyps = functions.cloneps("destroy",hold,90,120)
			functions.particolors(hold.destroyps,r,g,b)
			if c == "paddle" and not gameover then
				points = points + 1
				if not pad.d then pad.d = 1.5 end
				if world.r < 60 then
					world.r = world.r + 1
				end
			elseif c == "world" and not gameover then
				if points > 1 then
					points = points - 1
					if points < 55 then
						world.r = world.r - 1
					end
				else
					points = 0
					gameover = true
					music:setLooping(false)
					world.r = 5
				end
			end
			magn.x = magn.x < 100 and magn.x + love.math.random(100 - magn.x) or magn.x
			magn.y = magn.y < 100 and magn.y + love.math.random(100 - magn.y) or magn.y
			magnitud.set = true
			hold.ps:stop()
			hold.ps:setEmitterLifetime(0)
			return hold
		end
		return hold
	else
		if hold.destroyps:isStopped() then
			return nil
		else
			hold.destroyps:update(dt)
			return hold
		end
	end
end
ball.draw = function (hold)
	if not hold.destroyed then
		love.graphics.draw(hold.ps)
	else
		love.graphics.draw(hold.destroyps)
	end
end
return ball