--Main
local keyp = 1
local sequence = {
	"down","down","up","up","left","right","left","right","b","a"
}
love.load = function ()
	--Projectiles functions
	ball = require "ball"
	--Image and math and some other functions
	utils = require "utils"
	--Screen management functions
	screen = require "screen"
	--Kikito's Tweening library, modified for use in this game
	tween = require "tween"
	--Update the screen info
	screen.update()
	--Resources
	music = love.audio.newSource("papa.ogg","stream")
	music:setLooping(true)
	wor = love.graphics.newImage("earth.png")
	gfont = love.graphics.newFont(50)
	pfont = love.graphics.newFont("segments.ttf",40)
	--The world and the paddle
	world = {}
	pad = { 
		rm = 65,
		mr = 70,
		a = 0,
		d = 1.5,
	}
	--Variable set
	utils.set()
	top = 0
	utils.earthquake()
	quake = tween.new(.4,earth,magn,"inOutBounce")
end
love.update = function (dt)
	if love.touch then
		n = love.touch.getTouchCount()
		if n > 1 then
			utils.bang(true)
		else
			utils.bang(false)
		end
	end
	if not started then
		pause = true
	end
	if magnitud.set then
		magnitud.set = false
		utils.earthquake()
		quake:set(0,magn,earth)
	end
	local finished = quake:update(dt)
	if finished then utils.earthquake() end
	if gameover or pause then utils.bang(false) end --Dont use the power when the game is paused or over
	if dt > 0.03 then dt = 0.03 end --at least 30 FPS
	top = (points > top and points) or top --Top scores
	if pause then dt = 0 end --Dont update when paused
	if not gameover then playedtime = playedtime + dt end --Check the time of the game
	time = time + dt
	if dir and not pause then
		x,y = love.mouse.getX(),love.mouse.getY()
		_,pad.a = math.pol(x - screen.halfw,y - screen.halfh)
	end
	nedad = (((points/10) < 1.7 and (points/10)) or 1.7)
	goofigoo = goofigoo < nedad and nedad or goofigoo
	if time > 2- goofigoo then
		drawer[#drawer + 1] = ball.create()
		time = 0
	end
	for k,v in pairs(drawer) do
		drawer[k] = ball.update(dt,drawer[k],pad)
	end
end
love.draw = function ()
	if low then
		love.graphics.setBackgroundColor(255,0,0)
	else
		love.graphics.push()
		local shake = (gameover and 4) or 1
		love.graphics.translate(shake * math.sin(earth.x/50 * math.pi) ,shake * math.sin(earth.y/50 * math.pi))
		love.graphics.setColor(utils.color())
		screen.fondo()
		love.graphics.setFont(pfont)
		love.graphics.push()
		love.graphics.translate(screen.halfw,screen.halfh)
		local asd = world.r * (200/70)
		utils.imagen("fit",wor,-asd,-asd,asd*2,asd*2)()
		if not gameover then love.graphics.setColor(255,255,255)end
		love.graphics.setInvertedStencil(function()
			love.graphics.circle("fill",0,0,pad.rm)
		end)
		if not pad.d then pad.d = 1.5 end
		love.graphics.arc("fill",0,0,pad.mr,pad.a + pad.d/2,pad.a - pad.d/2)
		love.graphics.setStencil()
		for k,v in pairs(drawer) do
			ball.draw(drawer[k])
		end
		love.graphics.pop()
		love.graphics.pop()
		love.graphics.printf(string.format("%03d",points),0,20,screen.w,"right")
		love.graphics.printf(string.format("%04d T",math.floor(playedtime)),0,20,screen.w,"center")
		love.graphics.printf(string.format("%03d",top),0,20,screen.w,"left")
		if gameover then
			love.graphics.setFont(gfont)
			love.graphics.setColor(255,255,255)
			love.graphics.printf("GAME OVER",0,screen.halfh - 25,screen.w,"center")
			love.graphics.setColor(255,0,0)
		end
		if pause or not started then 
			love.graphics.setColor(0,0,0,200)
			love.graphics.rectangle("fill",0,0,screen.w,screen.h)
			love.graphics.setColor(255,255,255)
			screen.controls() 
		end
	end
end
--Callbacks
love.keypressed = function (k, isrepeat)
	if k == "r" or k == "search" then
		if sequence[keyp] == "r" then
			keyp = keyp + 1
		else
			keyp = 1
			utils.set()
			music:resume()
		end
	elseif k == "p" or k == "menu" then
		keyp = 1
		pause = not pause
	elseif k == " " and not gameover then
		keyp = 1
		utils.bang(true)
	elseif k == "f11" then
		keyp = 1
		screen.full()
	elseif k == "escape" then
		keyp = 1
		love.event.quit()
	elseif k == "return" then
		keyp = 1
		if not started then 
			started = true 	
			music:play()
		end
		pause = false
	elseif k == sequence[keyp] then
		keyp = keyp + 1
		if keyp > #sequence then
			keyp = 0
			points = 200
			world.r = 60
			gameover = false
		end
	else
		keyp = 1
	end
end
love.keyreleased = function (k, isrepeat)
	if k == " " then
		utils.bang(false)
	end
end
love.mousepressed = function (x,y,b,istouch)
	if b == "l" then
		if gameover then
			keyp = 1
			utils.set()
			music:resume()
			pause = false
		end
		if not started then 
			started = true 	
			music:play()
			pause = false
		end
		if istouch == nil then
			utils.bang(true)
		end
	end
end
love.mousereleased = function (x,y,b)
	if b == "l" then
		utils.bang(false)
	end
end
love.quit = function ()
	print(screen.mouse(love.mouse.getX(),love.mouse.getY()))
end

love.lowmemory = function ()
	pause = true
	low = true
end