local currentcolor = 1
local ccolor = {255,0,0}
local utils = {
	imagen = function (typ, image, vx, vy, w, h)
		local typ = typ:lower()
		local width, height = image:getDimensions()
		local scale, offset
		if not(typ == "expand" or typ == "center") then
			local scl
			if h/height > w/width then 
				if typ == "fit" then scl = w/width elseif typ == "fill" then scl = h/height end
			else 
				if typ == "fit" then scl = h/height elseif typ == "fill" then scl = w/width end
			end
			scale = {x = scl, y = scl}
			offset = {
				x = (w - width*scale.x) / 2;
				y = (h - height*scale.y) / 2
			}
		elseif typ == "expand" then
			scale = {
				x = w/width;
				y = h/height
			}
			offset = {x = 0, y = 0}
		elseif typ == "center" then
			scale = {x = 1, y = 1}
			offset = {
				x = (w - width) / 2;
				y = (h - width) / 2
			}
		end
		if not (offset and scale) then return end
		return function(r, sx, sy, ox, oy, kx, ky)
			local r, ox, oy, sx, sy, kx, ky = r or 0, ox or 0, oy or 0, sx or 1, sy or 1, kx or 0, ky or 0
			love.graphics.draw(image, vx + offset.x, vy + offset.y, r, scale.x * sx, scale.y * sy, ox, oy, kx, ky) 
		end
	end,
	color = function (particle)
		local nextcolor = {
			{255,0,0};
			{255,255,0};
			{0,255,0};
			{0,255,255};
			{0,0,255};
			{255,0,255}
		}
		local host = points
		if host >= 100 then
			if not particle then
				for j = 1, 3 do
					ccolor[j] = ccolor[j] + (((nextcolor[currentcolor][j] - ccolor[j])>0 and 5) or ((nextcolor[currentcolor][j] - ccolor[j])<0 and -5) or 0)
					ccolor[j] = math.ceil(ccolor[j])
					if ccolor[1] == nextcolor[currentcolor][1] and ccolor[3] == nextcolor[currentcolor][3] and ccolor[2] == nextcolor[currentcolor][2] then
						currentcolor = (currentcolor>=6 and 1) or currentcolor+1
					end
				end
			end
			return ccolor[1],ccolor[2],ccolor[3]
		elseif host >= 80 then
			local p = (host - 80) * ((200-127)/20)
			local o = (host - 80) * (200/20)
			return o,128 + p,128 + p
		elseif host >= 60 then
			local p = (host - 60) * (127/20)
			return 0,255 - p,255 -p
		elseif host >= 40 then
			local p = (host - 40) * (255/20)
			return 0,p,255
		elseif host == 0 then
			return 255,0,0
		elseif host < 40 then
			local p = host * (255/40)
			return 255 - p,0,p
		end
	end,
	set = function()
		gameover = false
		goofigoo = 0
		nedad = 0
		drawer = {}
		world.r = 15
		points = 10
		pad.d = 1.5
		time = 0
		dir = true
		playedtime = 0
		screen.move = {
			x = 0,
			y = 0
		}
	end,
	earthquake = function ()
		earth = {
			x = 0,
			y = 0
		}
	end,
	twopi = 2*math.pi,
	bang = function(b)
		if b then
			pad.mr = 200
			pad.d = 0.3
			dir = false
		else
			pad.mr = 70
			pad.d = 1.5
			dir = true
		end
	end
}
function math.rec (r,a)
	local cos, sin = math.cos, math.sin
	return r * cos(a), r * sin(a)
end
function math.pol (x,y)
	local atan,sqrt = math.atan2,math.sqrt
	return sqrt(x * x + y * y),atan(y,x)
end
return utils